'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _is = require('./is');

var _is2 = _interopRequireDefault(_is);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 圆形布局
 * @author can.yang@tongdun.cn
 */
var Circle = function (_Base) {
  (0, _inherits3.default)(Circle, _Base);

  /**
   * 是否避免重叠
   * @type  {boolean}
   */
  function Circle(options, simulation) {
    (0, _classCallCheck3.default)(this, Circle);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Circle.__proto__ || (0, _getPrototypeOf2.default)(Circle)).call(this, options, simulation));

    _this.clockwise = true;
    _this.startAngle = 3 / 2 * Math.PI;

    if (!_is2.default.nil(options.clockwise)) {
      _this.clockwise = options.clockwise;
    }
    if (!_is2.default.nil(options.startAngle)) {
      _this.startAngle = options.startAngle;
    }
    if (!_is2.default.nil(options.sort)) {
      _this.sort = options.sort;
    }
    if (!_is2.default.nil(options.center)) {
      _this.center = options.center;
    }
    return _this;
  }
  /**
   * 起始角度
   * @type  {boolean}
   */


  (0, _createClass3.default)(Circle, [{
    key: 'execute',
    value: function execute(_ref) {
      var _this2 = this;

      var _ref$beforeExecute = _ref.beforeExecute,
          beforeExecute = _ref$beforeExecute === undefined ? function () {} : _ref$beforeExecute;
      var _simulation = this.simulation,
          nodes = _simulation.nodes,
          links = _simulation.links;

      var radius = void 0;
      if (nodes.length <= 1) {
        radius = 0;
      } else {
        radius = Math.min(this.width, this.height) / 2;
      }
      var center = this.center ? this.center : {
        x: this.width / 2,
        y: this.height / 2
      };
      var angleStep = 2 * Math.PI / nodes.length;
      this.sort && nodes.sort(this.sort);
      beforeExecute && beforeExecute(nodes);
      nodes.forEach(function (node, i) {
        var theta = _this2.startAngle + i * angleStep * (_this2.clockwise ? 1 : -1);
        var rx = radius * Math.cos(theta);
        var ry = radius * Math.sin(theta);
        node.fx = node.x = center.x + rx;
        node.fy = node.y = center.y + ry;
      });
    }
  }]);
  return Circle;
}(_base2.default);

exports.default = Circle;
//# sourceMappingURL=circle.js.map