'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _dagre = require('dagre');

var _dagre2 = _interopRequireDefault(_dagre);

var _is = require('./is');

var _is2 = _interopRequireDefault(_is);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Dagre = function (_Base) {
  (0, _inherits3.default)(Dagre, _Base);

  function Dagre(options, simulation) {
    (0, _classCallCheck3.default)(this, Dagre);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Dagre.__proto__ || (0, _getPrototypeOf2.default)(Dagre)).call(this, options, simulation));

    (0, _assign2.default)(_this, {
      rankdir: 'TB',
      align: undefined,
      nodesep: 50,
      edgesep: 10,
      ranksep: 50,
      marginx: 0,
      marginy: 0,
      acyclicer: undefined,
      useEdgeControlPoint: true,
      ranker: 'network-simplex',
      callback: null,
      nodeWidth: 20,
      nodeHeight: 20
    }, options);
    return _this;
  }

  (0, _createClass3.default)(Dagre, [{
    key: 'getValue',
    value: function getValue(name) {
      var value = this[name];
      if (_is2.default.Function(value)) {
        return value();
      }
      return value;
    }
    // 执行布局

  }, {
    key: 'execute',
    value: function execute() {
      var _this2 = this;

      var _simulation = this.simulation,
          nodes = _simulation.nodes,
          links = _simulation.links,
          nodeIdKey = _simulation.nodeIdKey,
          sourceKey = _simulation.sourceKey,
          targetKey = _simulation.targetKey,
          nodesMap = _simulation.nodesMap;

      var nodeMap = {};
      var g = new _dagre2.default.graphlib.Graph();
      var useEdgeControlPoint = this.useEdgeControlPoint;
      g.setGraph({
        rankdir: this.getValue('rankdir'),
        align: this.getValue('align'),
        nodesep: this.getValue('nodesep'),
        edgesep: this.getValue('edgesep'),
        ranksep: this.getValue('ranksep'),
        marginx: this.getValue('marginx'),
        marginy: this.getValue('marginy'),
        acyclicer: this.getValue('acyclicer'),
        ranker: this.getValue('ranker')
      });
      g.setDefaultEdgeLabel(function () {
        return {};
      });
      nodes.forEach(function (node) {
        g.setNode(node[nodeIdKey], { width: _this2.nodeWidth, height: _this2.nodeHeight });
        nodeMap[node[nodeIdKey]] = node;
      });
      links.forEach(function (link) {
        var source = link.source[nodeIdKey],
            target = link.target[nodeIdKey];
        g.setEdge(source, target);
      });
      _dagre2.default.layout(g);
      g.nodes().forEach(function (v) {
        var node = g.node(v);
        nodeMap[v].fx = nodeMap[v].x = node.x;
        nodeMap[v].fy = nodeMap[v].y = node.y;
      });
      g.edges().forEach(function (e, i) {
        var edge = g.edge(e);
        if (useEdgeControlPoint) {
          links[i].controlPoints = edge.points.slice(1, edge.points.length - 1);
        }
      });
    }
  }]);
  return Dagre;
}(_base2.default); /**
                    * 分层布局
                    * https://github.com/dagrejs/dagre/wiki
                    * @author can.yang@tongdun.cn
                    */


exports.default = Dagre;
//# sourceMappingURL=dagre.js.map